/*1. Zastosowanie domniemanych operatorow new i delete
  2. Zastosowanie przeciazonych operatorow new (bez dodatkowego
     parametru) i delete
  3. Zastosowanie przeciazonych operatorow new (z dodatkowym
     parametrem) i delete

 Cel zadania: Zliczanie wszystkich obiektow typu punkt i osobno
 obiektow dynamicznych typu punkt za pomoca pol statycznych
 aktualizowanych w przeciazonych operatorach new i delete
 (przy zliczaniu obiektow dynamicznych) oraz konstruktorach i
 destruktorze (przy zliczaniu wszystkich obiektow).

 Klasa punkt powinna zawierac:
 * konstruktor zwykly z domniemanymi parametrami do inicjowania
   skladowych x i y, zwiekszajacy o 1 wartosc pola statycznego
   ile_punktow (licznika wszystkich obiektow)
 * konstruktor kopiujacy zwiekszajacy o 1 wartosc pola statycznego
   ile_punktow (licznika wszystkich obiektow)
 * destruktor zmniejszajacy o 1 wartosc pola statycznego
   ile_punktow (licznika wszystkich obiektow)
 * przeciazony operator new bez dodatkowego parametru typu int,
   ktory tworzy obiekt za pomoca globalnego operatora new oraz
   zwieksza o 1 wartosc pola statycznego ile_p_dyn (licznika
   obiektow dynamicznych)
 * przeciazony operator new z dodatkowym parametrem typu int,
   ktory tworzy obiekt za pomoca globalnego operatora new,
   zwieksza o 1 wartosc pola statycznego ile_p_dyn (licznika
   obiektow dynamicznych) oraz wyprowadza napis, gdy wartosc
   dodatkowego parametru jest rozna od zera
 * 2 metody statyczne przekazujace zawartosc pol statycznych, sta-
   nowiacych liczniki wszystkich obiektow oraz tylko dynamicznych.
 * definicje przeciazonego operatora delete, ktory usuwa obiekt
   za pomoca globalnego operatora delete oraz zmniejsza o 1 wartosc
   pola statycznego ile_p_dyn (licznika obiektow dynamicznych)
 * metody typu const przeznaczone do czytania skladowych x i y

 Wykonac:
 1. Sprawdzic dzialanie programu lab4_a.exe.
 2. Wykonac plik zrodlowy punkt4_a.cpp z definicjami skladowych klasy,
    punkt, zastosowac dyrektywy uniemozliwiajace ponowna kompilacje
    pliku naglowkowego punkt4_a.h. Wykonac projekt laczacy pliki
    lab4_a.cpp i punkt4_a.cpp.

 Pytania kontrolne:
 1. Przedstaw sposob tworzenia obiektow dynamicznych za pomoca
    operatorow new: obu przeciazonych i domniemanego oraz usuwania
    z pamieci za pomoca operatora przeciazonego delete i domniemanego
 2. Dlaczego nieprawidlowo jest wyznaczana liczba obiektow
    dynamicznych?*/

#include <iostream.h>
#include "punkt4_a.h"
#include <conio.h>

char s1[]="Wszystkie punkty = ";
char s2[]="Dynamiczne punkty = ";
void wyswietl(punkt&);
void wyswietl(punkt*);
void wyswietl(int, char[]);
void main()
{  punkt *p1;
   clrscr();
 { wyswietl(punkt::liczba_punktow(),s1);
   wyswietl(punkt::liczba_p_dyn(),s2);
     //dodatkowy parametr w przeciazonym operatorze new
   p1=new (1) punkt(2,2);       //konstruktor zwykly, obiekt dynamiczny
     //brak dodatkowego parametru w przeciazonym operatorze new
   punkt *p2=new punkt(1, 5);  //konstruktor zwykly , obiekt dynamiczny
     //operator new domniemany
   punkt *p3=::new punkt(2, 7); //konstruktor zwykly , obiekt dynamiczny
   punkt p4= *p3;
   wyswietl(punkt::liczba_punktow(),s1);
   wyswietl(punkt::liczba_p_dyn(),s2);
   wyswietl(*p1);
   wyswietl(p2);
   wyswietl(p3);
   wyswietl(p4);
   delete p2;
   ::delete p3;
   wyswietl(punkt::liczba_punktow(),s1);
   wyswietl(punkt::liczba_p_dyn(),s2);
  } //tutaj koniec bloku i zostaja usuniete wszystkie obiekty powowlane
   //w poprzednim bloku
   wyswietl(punkt::liczba_punktow(),s1);
   wyswietl(punkt::liczba_p_dyn(),s2);
   delete p1;
   wyswietl(punkt::liczba_punktow(),s1);
   wyswietl(punkt::liczba_p_dyn(),s2);
 }
void wyswietl(punkt& p)
{
 cout <<"Moje wspolrzedne: " << p.odcieta() << " "<< p.rzedna() << '\n';
 getch();
}

void wyswietl(punkt* p)
{
 cout <<"Moje wspolrzedne: " << p->odcieta() << " "<< p->rzedna() << '\n';
 getch();
}

void wyswietl(int w,char napis[])
{
 cout <<"Liczba punktow: " << napis << w << '\n';
 getch();
 }
