/* 1. Klasa zawierajaca dynamiczna tablice elementow typu int.
   2. Przeciazenie operatora wywolania funkcji do realizacji
      indeksowania dwuwymiarowej tablicy.
   3. Przeciazenie operatora << na rzecz dowolnej klasy zadefiniowanej
      prze programiste.

   Klasa figura realizuje te same czynnosci, co klasa figura z lab4_b,
   lecz sa one implementowane w inny sposob:
   * dynamiczna tablica wspolrzednych Figura jest teraz jednowywiarowa 
     tablica dynamiczna traktowana jako dwuwymarowa o liczbie
     wierszy max_w oraz liczbie kolumn max_kol. Pole ile przechowuje
     liczbe aktualnie wprowadzonych wspolrzednych.
   * zamiast przeciazonego operatora indeksowania do zapisu, nalezy wykonac
     operator << jako metode, gdzie lewy argument jest obiektem klasy figura,
     a prawym argument typu int (kolejne wspolrzedne). Wynikiem
     dzialania jest referencja do lewego argumentu.
   * zamiast przeciazonego operatora indeksowania do czytania
     nalezy wykonac operator()(int,int) jako metode, zastepujacy
     indeksowanie [][] w tablicy dwuwymiarowej, niemozliwy do
     przeciazenia w C++(mozna przeciazac tylko operator [] dwuargumentowy)

 Wykonac:
 1.Sprawdz dzialanie programu lab4_c.exe
 2.Dokonaj analizy programu lab4_c.cpp, wprowadzajacego wspolrzedne
   wierzcholkow wielokata o maksymalnej liczbie okreslonej
   liczba max i wyswietlajacego wspolrzedne na ekranie.
 3.Wykonaj plik modulowy fig4_c.cpp zawierajacy definicje skladowych
   klasy figura. Nalezy zabezpieczyc metody przed czytaniem
   elementow tablicy Figura poza jej ograniczajacymi indeksami
   max_w*max_kol.
 4.Wykonaj i zastosuj przeciazony operator wywolania funkcji
   do indeksowania tablicy dwuwymiarowej, sluzacy do zapisu danych
   i zastosuj go w ramach prob do wprowadzania danych w funkcji:
       void wprowadz_punkty(figura&);
 5.Zastosuj dyrektywy uniemozliwiajace ponowna kompilacje
   pliku naglowkowego fig4_c.h. Wykonaj projekt laczacy pliki
   lab4_c.cpp oraz fig4_c.cpp.

 Pytania kontrolne:
 1. Jakie korzysci wynikaja z zastosowania jednowymiarowej dynamicznej
    tablicy elementow typu int do reprezentowania dwuwymiarowej tablicy
    wspolrzednych punktu? Jakie ograniczenia wynikalyby z zastosowania
    dynamicznej dwuwymiarowej tablicy elementow typu int, wykonanej
    za pomoca wskaznika zdefiniowanego jako: int (*tab)[2]?
 2. Wskaz miejsca w pliku modulowym, gdzie mozna w ciele metod uzyc
    przeciazonych operatorow << oraz wywolania funkcji ()(jako indeksowania)
 3. Scharakteryzuj sposob wykonania konstruktorow i destruktora.
 4. Scharakteryzuj zastosowanie const w metodach klasy figura
    i przy przekazaniu parametrow (np funkcja wyswietl)*/

#include <iostream.h>
#include <iomanip.h>
#include <conio.h>
#include "fig4_c.h"
 void wprowadz_punkty(figura&);//przekazanie przez referencje-zapis
 void wyswietl(const figura);  //przekazanie przez wartosc- odczyt
 void  main()
 {do
   {
     figura wielokat(5, 2);
     cout<<"Nalezy wprowadzic wspolrzedne (a,b) pieciu roznych punktow\n";
     getch();
     clrscr();			//niezalezna funkcja, gdyz figura nie
     wprowadz_punkty(wielokat); //powinna wprowadzac danych
     wielokat.rysuj();   
     getch();
     clrscr();
     wyswietl(wielokat); //niezalezna funkcja, gdyz figura nie musi
			 //wyswietlac wartosci swoich wspolrzednych
     cout<<" Jesli koniec, nacisnil ESC, dalej - dowolny klawisz\n";
    }while (getch() != 27);
    clrscr();
 }

 void wprowadz_punkty(figura& wielokat)
  {
    int ile_w=wielokat.podaj_wsp_x(),a;
    int ile_kol=wielokat.podaj_wsp_y();
    for (int i=0;i<ile_w;i++)
      for(int j=0;j<ile_kol;j++)
	 {clrscr();
   	  cout<< "Podaj wielokat["<<i<<", "<<j<<"] = ";
	  cin >> a; 
          wielokat<<a;
	 }
     clrscr();
   }

 void wyswietl(const figura wielokat)
  {
    getch();
    clrscr();
    int ile_w=wielokat.podaj_wsp_x();
    int ile_kol=wielokat.podaj_wsp_y();
    for (int i=0;i<ile_w;i++)
      {
	for(int j=0;j<ile_kol;j++)
	 // operator() na kopii obiektu przekazanego przez wartosc
	 cout<< setw(15)<<"Wielokat["<<i<<","<<j<<"] "<<
	        setw(5)<<wielokat(i,j);
	cout<<'\n';
       }
  }
